Index: /trunk/src/sh_unix.c
===================================================================
--- /trunk/src/sh_unix.c	(revision 584)
+++ /trunk/src/sh_unix.c	(revision 1)
@@ -4363,165 +3048,92 @@
       if (linksize < 0) 
 	{
-	  char errbuf[SH_ERRBUF_SIZE];
 	  linksize = errno;
 	  tmp2 = sh_util_safe_name (theFile->fullpath);
-	  SH_MUTEX_LOCK(mutex_thread_nolog);
 	  sh_error_handle (level, FIL__, __LINE__, linksize, MSG_FI_RDLNK,
-			   sh_error_message (linksize, errbuf, sizeof(errbuf)), tmp2);
-	  SH_MUTEX_UNLOCK(mutex_thread_nolog);
+			   sh_error_message (linksize), tmp2);
 	  SH_FREE(tmp2);
 	  SH_FREE(linknamebuf);
-	  theFile->link_path = sh_util_strdup("-");
 	  SL_RETURN((-1),_("sh_unix_getinfo"));
 	}
-
-      if (linknamebuf[0] == '/') 
-	{
-	  theFile->link_path = sh_util_strdup (linknamebuf);
-	} 
-      else 
-	{
-	  tmp = sh_util_dirname(theFile->fullpath);
-	  if (tmp) {
-	    theFile->link_path = SH_ALLOC(PATH_MAX);
-	    sl_strlcpy (theFile->link_path, tmp, PATH_MAX);
-	    SH_FREE(tmp);
-	  } else {
-	    theFile->link_path = SH_ALLOC(PATH_MAX);
-	    theFile->link_path[0] = '\0';
+    
+    if (linknamebuf[0] == '/') 
+      {
+	sl_strlcpy (theFile->linkpath, linknamebuf, PATH_MAX);
+      } 
+    else 
+      {
+	tmp = sh_util_basename(theFile->fullpath);
+	sl_strlcpy (theFile->linkpath, 
+		    tmp, 
+		    PATH_MAX);
+	SH_FREE(tmp);
+	sl_strlcat (theFile->linkpath, 
+		    "/", PATH_MAX);
+	sl_strlcat (theFile->linkpath, 
+		    linknamebuf, 
+		    PATH_MAX);
+      }
+    
+    /* stat the link
+     */
+    stat_return = retry_lstat (FIL__, __LINE__, theFile->linkpath, &lbuf); 
+
+    /* check for error
+     */
+    if (stat_return != 0) 
+      { 
+	stat_return = errno;
+	tmp  = sh_util_safe_name (theFile->fullpath);
+	tmp2 = sh_util_safe_name (theFile->linkpath);
+	if (stat_return != ENOENT)
+	  { 
+	    sh_error_handle (level, FIL__, __LINE__, stat_return, 
+			     MSG_FI_LSTAT,
+			     sh_error_message (stat_return), tmp2);
 	  }
-	  /*
-	   * Only attach '/' if not root directory. Handle "//", which
-	   * according to POSIX is implementation-defined, and may be
-	   * different from "/" (however, three or more '/' will collapse
-	   * to one).
-	   */
-	  tmp = theFile->link_path; while (*tmp == '/') ++tmp;
-	  if (*tmp != '\0')
-	    {
-	      sl_strlcat (theFile->link_path, "/", PATH_MAX);
-	    }
-	  sl_strlcat (theFile->link_path, linknamebuf, PATH_MAX);
-	}
+	else 
+	  {
+	    /* a dangling link -- everybody seems to have plenty of them 
+	     */
+	    sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_FI_DLNK,
+			     tmp, tmp2);
+	  }
+	theFile->linkisok = BAD;
+	SH_FREE(tmp);
+	SH_FREE(tmp2);
+	SH_FREE(linknamebuf);
+	/* 
+	 * changed Tue Feb 10 16:16:13 CET 2004:
+	 *  add dangling symlinks into database
+	 * SL_RETURN((-1),_("sh_unix_getinfo")); 
+	 */
+	theFile->linkmode = 0;
+	SL_RETURN((0),_("sh_unix_getinfo")); 
+      }
+
+    theFile->linkisok = GOOD;
       
-      /* stat the link
-       */
-      stat_return = retry_lstat (FIL__, __LINE__, theFile->link_path, &lbuf); 
-      
-      /* check for error
-       */
-      if (stat_return != 0) 
-	{ 
-	  stat_return = errno;
-	  tmp  = sh_util_safe_name (theFile->fullpath);
-	  tmp2 = sh_util_safe_name (theFile->link_path);
-	  if (stat_return != ENOENT)
-	    { 
-	      uid_t euid;
-	      char errbuf[SH_ERRBUF_SIZE];
-
-	      (void) sl_get_euid(&euid);
-	      SH_MUTEX_LOCK(mutex_thread_nolog);
-	      sh_error_handle (level, FIL__, __LINE__, stat_return, 
-			       MSG_FI_STAT,
-			       _("lstat (link target)"),
-			       sh_error_message (stat_return,errbuf, sizeof(errbuf)), 
-			       (long) euid,
-			       tmp2);
-	      SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	    }
-	  else 
-	    {
-	      /* a dangling link -- everybody seems to have plenty of them 
-	       */
-	      SH_MUTEX_LOCK(mutex_thread_nolog);
-	      sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_FI_DLNK,
-			       tmp, tmp2);
-	      SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	    }
-	  theFile->linkisok = BAD;
-	  SH_FREE(tmp);
-	  SH_FREE(tmp2);
-	  SH_FREE(linknamebuf);
-	  /* 
-	   * changed Tue Feb 10 16:16:13 CET 2004:
-	   *  add dangling symlinks into database
-	   * SL_RETURN((-1),_("sh_unix_getinfo")); 
-	   */
-	  theFile->linkmode = 0;
-	  SL_RETURN((0),_("sh_unix_getinfo")); 
-	}
-      
-      theFile->linkisok = GOOD;
-      
-      
-      /* --- Determine file type. ---
-       */
-      sh_unix_getinfo_type (&lbuf, &type, theFile->link_c_mode);
-      theFile->type = type;
-      
-      /* --- Determine permissions. ---
-       */
-      sh_unix_getinfo_mode (&lbuf, &mode, theFile->link_c_mode);
-      theFile->linkmode = lbuf.st_mode;
-      
-      /* --- Output the link. ---
-       */
-      if (theFile->linkisok == GOOD) 
-	{
-	  tmp2 = sh_util_safe_name (linknamebuf);      
-	  SH_MUTEX_LOCK(mutex_thread_nolog);
-	  sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_FI_LLNK,
-			   theFile->link_c_mode, tmp2);
-	  SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	  SH_FREE(tmp2);
-	}
-      SH_FREE(linknamebuf);
-    }
-  else /* not a link, theFile->c_mode[0] != 'l' */
-    {
-      if (content)
-	{
-#ifdef HAVE_LIBZ
-	  unsigned long   clen;
-	  unsigned char * compressed;
-#ifdef HAVE_COMPRESSBOUND
-	  clen       = compressBound(sh_string_len(content));
-#else
-	  if (sh_string_len(content) > 10*SH_TXT_MAX)
-	    clen = SH_TXT_MAX;
-	  else
-	    clen = 13 + (int)(1.0001*sh_string_len(content));
-#endif
-	  compressed = SH_ALLOC(clen);
-	  if (Z_OK == compress(compressed, &clen, 
-			       (unsigned char *) sh_string_str(content), 
-			       sh_string_len(content)))
-	      {
-		if (clen < SH_TXT_MAX)
-		  {
-		    sh_util_base64_enc_alloc (&(theFile->link_path), 
-					      (char *) compressed, clen);
-		  }
-		else
-		  {
-		    char tmsg[128];
-		    char * tpath = sh_util_safe_name (theFile->fullpath);
-		    sl_snprintf(tmsg, sizeof(tmsg), 
-				_("compressed file too large (%lu bytes)"),
-				clen);
-		    SH_MUTEX_LOCK(mutex_thread_nolog);
-		    sh_error_handle (SH_ERR_WARN, FIL__, __LINE__, -1, 
-				     MSG_E_SUBGPATH, tmsg, 
-				     _("sh_unix_getinfo"), tpath);
-		    SH_MUTEX_UNLOCK(mutex_thread_nolog);
-		    SH_FREE(tpath);
-		  }
-	      }
-	  SH_FREE(compressed);
-#endif
-	  sh_string_destroy(&content);
-	}
-    } 
+
+    /* --- Determine file type. ---
+     */
+    sh_unix_getinfo_type (&lbuf, &type, theFile->link_c_mode);
+    theFile->type = type;
+  
+    /* --- Determine permissions. ---
+     */
+    sh_unix_getinfo_mode (&lbuf, &mode, theFile->link_c_mode);
+    theFile->linkmode = lbuf.st_mode;
+
+    /* --- Output the link. ---
+     */
+    if (theFile->linkisok == GOOD) 
+      {
+	tmp2 = sh_util_safe_name (linknamebuf);      
+	sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_FI_LLNK,
+			 theFile->link_c_mode, tmp2);
+	SH_FREE(tmp2);
+      }
+    SH_FREE(linknamebuf);
+  }  
   SL_RETURN((0),_("sh_unix_getinfo"));
 }
@@ -4530,128 +3142,6 @@
 #endif
 
-int sh_unix_unlock(char * lockfile, char * flag)
-{
-  int         error = 0;
-  
-  SL_ENTER(_("sh_unix_unlock"));
-
-  if (sh.flag.isdaemon == S_FALSE && flag == NULL)
-    SL_RETURN((0),_("sh_unix_unlock"));
-
-  /* --- Logfile is not locked to us. ---
-   */
-  if (sh.flag.islocked == BAD && flag != NULL) 
-    SL_RETURN((-1),_("sh_unix_unlock"));
-
-  /* --- Check whether the directory is secure. ---
-   */
-  if (0 != tf_trust_check (lockfile, SL_YESPRIV))
-    SL_RETURN((-1),_("sh_unix_unlock"));
-
-  /* --- Delete the lock file. --- 
-   */
-  error = retry_aud_unlink (FIL__, __LINE__, lockfile);
-  
-  if (error == 0)
-    {
-      if (flag != NULL)
-	sh.flag.islocked = BAD; /* not locked anymore */
-    }
-  else if (flag != NULL)
-    {
-      char errbuf[SH_ERRBUF_SIZE];
-      error = errno;
-      sh_error_handle ((-1), FIL__, __LINE__, error, MSG_E_UNLNK,
-		       sh_error_message(error, errbuf, sizeof(errbuf)), 
-		       lockfile);
-      SL_RETURN((-1),_("sh_unix_unlock"));
-    }
-  SL_RETURN((0),_("sh_unix_unlock"));
-}
-
-int sh_unix_check_piddir (char * pidpath)
-{
-  static        struct stat   buf;
-  int           status = 0;
-  char        * pid_dir;
-  
-  SL_ENTER(_("sh_unix_check_piddir"));
-
-  pid_dir = sh_util_dirname (pidpath);
-
-  status = retry_lstat (FIL__, __LINE__, pid_dir, &buf);
-
-  if (status < 0 && errno == ENOENT)
-    {
-      status = mkdir (pid_dir, 0777);
-      if (status < 0)
-	{
-	  sh_error_handle ((-1), FIL__, __LINE__, status,
-			   MSG_E_SUBGEN, 
-			   _("Cannot create PID directory"),
-			   _("sh_unix_check_piddir"));
-	  SH_FREE(pid_dir);
-	  SL_RETURN((-1),_("sh_unix_check_piddir"));
-	}
-    }
-  else if (!S_ISDIR(buf.st_mode))
-    {
-      sh_error_handle ((-1), FIL__, __LINE__, status,
-		       MSG_E_SUBGEN, 
-		       _("Path of PID directory refers to a non-directory object"),
-		       _("sh_unix_check_piddir"));
-      SH_FREE(pid_dir);
-      SL_RETURN((-1),_("sh_unix_check_piddir"));
-    }
-  SH_FREE(pid_dir);
-  SL_RETURN((0),_("sh_unix_check_piddir"));
-}
-
-int sh_unix_lock (char * lockfile, char * flag)
-{
-  int filed;
-  int errnum;
-  char myPid[64];
-  SL_TICKET  fd;
-  extern int get_the_fd (SL_TICKET ticket);
-
-  SL_ENTER(_("sh_unix_lock"));
-
-  sl_snprintf (myPid, sizeof(myPid), "%ld\n", (long) sh.pid);             /* known to fit  */
-
-  if (flag == NULL) /* PID file, check for directory */
-    {
-      if (0 != sh_unix_check_piddir (lockfile))
-	{
-	  SL_RETURN((-1),_("sh_unix_lock"));
-	}
-    }
-
-  fd = sl_open_safe_rdwr (FIL__, __LINE__, 
-			  lockfile, SL_YESPRIV);      /* fails if file exists */
-
-  if (!SL_ISERROR(fd))
-    {
-      errnum = sl_write (fd, myPid, sl_strlen(myPid));
-      filed = get_the_fd(fd);
-      fchmod (filed, S_IRUSR|S_IWUSR|S_IRGRP|S_IROTH);
-      sl_close (fd);
-
-      if (!SL_ISERROR(errnum))
-	{
-	  if (flag != NULL)
-	    sh.flag.islocked = GOOD;
-	  SL_RETURN((0),_("sh_unix_lock"));
-	}
-    }
-
-  TPT((0, FIL__, __LINE__, _("msg=<open pid file failed>\n")));
-  if (flag != NULL)
-    sh.flag.islocked       = BAD;
-  SL_RETURN((-1),_("sh_unix_lock"));
-
-  /* notreached */
-}
-
+int sh_unix_unlock (char * lockfile, char * flag);
+int sh_unix_lock   (char * lockfile, char * flag);
 
 /* check whether file is locked
@@ -4667,4 +3157,14 @@
 
   SL_ENTER(_("sh_unix_test_and_lock"));
+
+  if (filename != NULL)
+    {
+      status = retry_lstat (FIL__, __LINE__, filename, &buf);
+
+      /* no logfile to lock
+       */
+      if (status < 0)
+	SL_RETURN((-1),_("sh_unix_test_and_lock"));
+    }
 
   status = retry_lstat (FIL__, __LINE__, lockfile, &buf);
@@ -4680,12 +3180,4 @@
 	    sh.flag.islocked = GOOD;
 	  SL_RETURN((0),_("sh_unix_test_and_lock"));
-	}
-      else
-	{
-	  sh_error_handle ((-1), FIL__, __LINE__, status,
-			   MSG_E_SUBGEN, 
-			   (filename == NULL) ? _("Cannot create PID file (1)") : _("Cannot create lock file (1)"),
-			   _("sh_unix_test_and_lock"));
-	  SL_RETURN((-1),_("sh_unix_test_and_lock"));
 	}
     }
@@ -4705,8 +3197,8 @@
       else
 	{
-	  sh_error_handle ((-1), FIL__, __LINE__, status,
-			   MSG_E_SUBGEN, 
-			   (filename == NULL) ? _("Cannot create PID file (2)") : _("Cannot create lock file (2)"),
-			   _("sh_unix_test_and_lock"));
+	   sh_error_handle ((-1), FIL__, __LINE__, status,
+			    MSG_E_SUBGEN, 
+			    (filename == NULL) ? _("Cannot create PID file") : _("Cannot create lock file"),
+			    _("sh_unix_test_and_lock"));
 	  SL_RETURN((-1),_("sh_unix_test_and_lock"));
 	}
@@ -4718,5 +3210,5 @@
   if (status >= 0)
     {
-       fd = sl_open_read (FIL__, __LINE__, lockfile, SL_YESPRIV);
+       fd = sl_open_read (lockfile, SL_YESPRIV);
        if (SL_ISERROR(fd))
 	 sh_error_handle ((-1), FIL__, __LINE__, fd,
@@ -4732,6 +3224,5 @@
       /* read the PID in the lock file
        */
-      status = sl_read (fd, line_in, sizeof(line_in));
-      line_in[sizeof(line_in)-1] = '\0';
+      status = sh_unix_getline (fd, line_in, sizeof(line_in)-1);
 
       /* convert to numeric
@@ -4760,5 +3251,5 @@
       sl_close(fd);
 
-      if (status > 0 && (unsigned int) status == sh.pid)
+      if (status == (int) getpid())
 	{
 	  if (filename != NULL)
@@ -4796,5 +3287,5 @@
 		       sh_error_handle ((-1), FIL__, __LINE__, status,
 					MSG_E_SUBGEN, 
-					(filename == NULL) ? _("Cannot create PID file (3)") : _("Cannot create lock file (3)"),
+					(filename == NULL) ? _("Cannot create PID file") : _("Cannot create lock file"),
 					_("sh_unix_test_and_lock"));
 		    }
@@ -4828,6 +3319,5 @@
 int sh_unix_write_lock_file(char * filename)
 {
-  size_t len;
-  int    res;
+  int i;
   char * lockfile;
 
@@ -4835,13 +3325,46 @@
     return (-1);
 
-  len = sl_strlen(filename);
-  if (sl_ok_adds(len, 6))
-    len += 6;
-  lockfile = SH_ALLOC(len);
-  sl_strlcpy(lockfile, filename,   len);
-  sl_strlcat(lockfile, _(".lock"), len);
-  res = sh_unix_test_and_lock(filename, lockfile);
+  i        = 6 + sl_strlen(filename);
+  lockfile = SH_ALLOC(i);
+  sl_strlcpy(lockfile, filename,   i);
+  sl_strlcat(lockfile, _(".lock"), i);
+  i = sh_unix_test_and_lock(filename, lockfile);
   SH_FREE(lockfile);
-  return res;
+  return i;
+}
+
+int sh_unix_unlock(char * lockfile, char * flag)
+{
+  int         error = 0;
+  
+  SL_ENTER(_("sh_unix_unlock"));
+
+  /* --- Logfile is not locked to us. ---
+   */
+  if (sh.flag.islocked == BAD && flag != NULL) 
+    SL_RETURN((-1),_("sh_unix_unlock"));
+
+  /* --- Check whether the directory is secure. ---
+   */
+  if (0 != tf_trust_check (lockfile, SL_YESPRIV))
+    SL_RETURN((-1),_("sh_unix_unlock"));
+
+  /* --- Delete the lock file. --- 
+   */
+  error = retry_aud_unlink (FIL__, __LINE__, lockfile);
+  
+  if (error == 0)
+    {
+      if (flag != NULL)
+	sh.flag.islocked = BAD; /* not locked anymore */
+    }
+  else if (flag != NULL)
+    {
+      error = errno;
+      sh_error_handle ((-1), FIL__, __LINE__, error, MSG_E_UNLNK,
+		       sh_error_message(error), lockfile);
+      SL_RETURN((-1),_("sh_unix_unlock"));
+    }
+  SL_RETURN((0),_("sh_unix_unlock"));
 }
 
@@ -4850,6 +3373,5 @@
 int sh_unix_rm_lock_file(char * filename)
 {
-  size_t len;
-  int res;
+  int i;
   char * lockfile;
 
@@ -4857,14 +3379,11 @@
     return (-1);
 
-  len = sl_strlen(filename);
-  if (sl_ok_adds(len, 6))
-    len += 6;
-  lockfile = SH_ALLOC(len);
-  sl_strlcpy(lockfile, filename,   len);
-  sl_strlcat(lockfile, _(".lock"), len);
-
-  res = sh_unix_unlock(lockfile, filename);
+  i        = 6 + sl_strlen(filename);
+  lockfile = SH_ALLOC(i);
+  sl_strlcpy(lockfile, filename,   i);
+  sl_strlcat(lockfile, _(".lock"), i);
+  i = sh_unix_unlock(lockfile, filename);
   SH_FREE(lockfile);
-  return res;
+  return i;
 }
 
@@ -4876,34 +3395,89 @@
 }
 
+int sh_unix_lock (char * lockfile, char * flag)
+{
+  struct stat buf;
+  int status;
+  int filed;
+  int errnum;
+  char myPid[64];
+  SL_TICKET  fd;
+  extern int get_the_fd (SL_TICKET ticket);
+
+
+  status = retry_lstat (FIL__, __LINE__, lockfile, &buf);
+  
+  SL_ENTER(_("sh_unix_lock"));
+
+  if (0 == status) 
+    {
+      if (flag != NULL)
+	sh.flag.islocked       = BAD;
+      SL_RETURN((-1),_("sh_unix_lock"));
+    }
+
+  sprintf (myPid, "%ld\n", (long) getpid());           /* known to fit  */
+
+  fd = sl_open_write (lockfile, SL_YESPRIV);
+
+  if (!SL_ISERROR(fd))
+    {
+      errnum = sl_write (fd, myPid, sl_strlen(myPid));
+      filed = get_the_fd(fd);
+      fchmod (filed, S_IRUSR|S_IWUSR|S_IRGRP|S_IROTH);
+      sl_close (fd);
+
+      if (!SL_ISERROR(errnum))
+	{
+	  if (flag != NULL)
+	    sh.flag.islocked = GOOD;
+	  SL_RETURN((0),_("sh_unix_lock"));
+	}
+    }
+
+  TPT((0, FIL__, __LINE__, _("msg=<open pid file failed>\n")));
+  if (flag != NULL)
+    sh.flag.islocked       = BAD;
+  SL_RETURN((-1),_("sh_unix_lock"));
+
+  /* notreached */
+}
+
 /* Test whether file exists
  */
-int sh_unix_file_exists(char * path)
+int sh_unix_file_stat(char * path)
 {
   struct stat buf;
 
+  SL_ENTER(_("sh_unix_file_stat"));
+
+  if (-1 == retry_stat(FIL__, __LINE__, path, &buf))
+    SL_RETURN(  (0), _("sh_unix_file_stat"));
+  else 
+    SL_RETURN( (-1), _("sh_unix_file_stat"));
+}
+
+
+/* Test whether file exists, is a character device, allows read
+ * access, and is not world writeable.
+ */
+int sh_unix_file_exists(int fd)
+{
+  struct stat buf;
+
   SL_ENTER(_("sh_unix_file_exists"));
 
-  if (0 == retry_lstat(FIL__, __LINE__, path, &buf))
-    SL_RETURN( S_TRUE,   _("sh_unix_file_exists"));
-
-  SL_RETURN( S_FALSE,  _("sh_unix_file_exists"));
-}
-
-
-/* Test whether file exists, is a character device, and allows read
- * access.
- */
-int sh_unix_device_readable(int fd)
-{
-  struct stat buf;
-
-  SL_ENTER(_("sh_unix_device_readable"));
-
   if (retry_fstat(FIL__, __LINE__, fd, &buf) == -1)
-    SL_RETURN( (-1), _("sh_unix_device_readable"));
-  if ( S_ISCHR(buf.st_mode) &&  0 != (S_IROTH & buf.st_mode) ) 
-    SL_RETURN( (0), _("sh_unix_device_readable"));
-
-  SL_RETURN( (-1), _("sh_unix_device_readable"));
+    SL_RETURN( (-1), _("sh_unix_file_exists"));
+  else if ( S_ISCHR(buf.st_mode) &&  0 != (S_IROTH & buf.st_mode)
+	    /*
+	     * #if !defined(__CYGWIN32__) && !defined(__CYGWIN__) 
+	     * && 0 == (S_IWOTH & buf.st_mode)
+	     * #endif
+	     */
+	    ) 
+    SL_RETURN( (0), _("sh_unix_file_exists"));
+  else 
+    SL_RETURN( (-1), _("sh_unix_file_exists"));
 }
 
@@ -4915,5 +3489,4 @@
 {
   static int init = 0;
-  struct stat buf;
 
   SL_ENTER(_("file_is_remote"));
@@ -4926,26 +3499,4 @@
   if (0 == sl_strncmp (sh.data.path, preq, 15))
     {
-      if (sh.data.path[15] != '\0') /* should be start of path */
-	{
-	  if (0 == stat(&(sh.data.path[15]), &buf))
-	    {
-	      SL_RETURN( S_FALSE, _("file_is_remote"));
-	    }
-	  else
-	    {
-	      char * tmp  = sh_util_safe_name (&(sh.data.path[15]));
-	      sh_error_handle((-1), FIL__, __LINE__, S_FALSE, MSG_E_SUBGPATH, 
-			      _("No local baseline database at expected path"), 
-			      _("file_is_remote"),
-			      tmp);
-	      SH_FREE(tmp);
-	    }
-	}
-      else
-	{
-	  sh_error_handle((-1), FIL__, __LINE__, S_FALSE, MSG_E_SUBGEN, 
-			  _("No local baseline database path known"), 
-			  _("file_is_remote"));
-	}
       SL_RETURN( S_TRUE, _("file_is_remote"));
     }
@@ -5039,6 +3590,4 @@
   unsigned long  page_start;
   int            page_refcount;
-  char           file[64];
-  int            line;
   struct sh_page_lt * next;
 } sh_page_l;
@@ -5084,13 +3633,10 @@
 
 #if defined(HAVE_MLOCK) && !defined(HAVE_BROKEN_MLOCK)
-
-SH_MUTEX_STATIC(mutex_mlock,PTHREAD_MUTEX_INITIALIZER);
-
-int sh_unix_mlock (const char * file, int line, void * in_addr, size_t len)
+int sh_unix_mlock (void * in_addr, size_t len)
 {
   int         num_pages;
   int         status = 0;
   int         pagesize;
-  sh_page_l * page_list;
+  sh_page_l * page_list = sh_page_locked;
   unsigned long addr;
 #ifdef TEST_MLOCK
@@ -5100,16 +3646,8 @@
   SL_ENTER(_("sh_unix_mlock"));
 
-  /* There's no cancellation point here, except if tracing is on
-   */
-  SH_MUTEX_LOCK_UNSAFE(mutex_mlock);
-
-  page_list = sh_page_locked;
-
   if (0 != page_locking)
     {
-      status = -1;
-      goto exit_mlock;
-    }
-
+      SL_RETURN((-1), _("sh_unix_mlock"));
+    }
   page_locking = 1;
 
@@ -5125,5 +3663,4 @@
    * addr is first page; num_pages is #(consecutive pages) to lock
    */
-
   while ((page_list != NULL) && (num_pages > 0))
     {
@@ -5160,17 +3697,13 @@
       page_list->page_start = addr;
       page_list->page_refcount = 1;
-      sl_strlcpy(page_list->file, file, 64);
-      page_list->line = line;
       status = mlock( (void *) addr, pagesize);
       if (status != 0)
 	{
 #ifdef TEST_MLOCK
-	  char errbuf[SH_ERRBUF_SIZE];
-	  fprintf(stderr, "mlock: error: %s\n", 
-		  sh_error_message(errno, errbuf, sizeof(errbuf)));
+	  fprintf(stderr, "mlock: error: %s\n", sh_error_message(errno));
 #endif
 	  SH_FREE(page_list);
 	  page_locking = 0;
-	  goto exit_mlock;
+	  SL_RETURN((status), _("sh_unix_mlock"));
 	}
       page_list->next = sh_page_locked;
@@ -5179,15 +3712,11 @@
       addr += pagesize;
     }
+
   page_locking = 0;
-
- exit_mlock:
-  SH_MUTEX_UNLOCK_UNSAFE(mutex_mlock);
-
   SL_RETURN((status), _("sh_unix_mlock"));
 }
 #else
-int sh_unix_mlock (const char * file, int line, void * in_addr, size_t len)
-{
-  (void) file;    (void) line;
+int sh_unix_mlock (void * in_addr, size_t len)
+{
   (void) in_addr; (void) len;
   return -1;
@@ -5199,8 +3728,8 @@
 {
   int         num_pages;
-  int         unlocked;
-  int         status;
+  int         unlocked = 0;
+  int         status   = 0;
   int         pagesize;
-  sh_page_l * page_list;
+  sh_page_l * page_list = sh_page_locked;
   sh_page_l * page_last;
   unsigned long addr;
@@ -5216,16 +3745,7 @@
   SL_ENTER(_("sh_unix_munlock"));
 
-  /* There's no cancellation point here, except if tracing is on
-   */
-  SH_MUTEX_LOCK_UNSAFE(mutex_mlock);
-
-  unlocked  = 0;
-  status    = 0;
-  page_list = sh_page_locked;
-
   if (0 != page_locking)
     {
-      status = -1;
-      goto exit_munlock;
+      SL_RETURN((-1), _("sh_unix_munlock"));
     }
   page_locking = 1;
@@ -5332,7 +3852,4 @@
 
   page_locking = 0;
-
- exit_munlock:
-  SH_MUTEX_UNLOCK_UNSAFE(mutex_mlock);
   SL_RETURN((status), _("sh_unix_munlock"));
 }
@@ -5347,48 +3864,17 @@
 int sh_unix_count_mlock()
 {
-  unsigned int i = 0;
-  char str[32][64];
-  sh_page_l * page_list;
+  int i = 0;
+  char str[128];
+  sh_page_l * page_list = sh_page_locked;
 
   SL_ENTER(_("sh_unix_count_mlock"));
-
-#if defined(HAVE_MLOCK) && !defined(HAVE_BROKEN_MLOCK)
-  /* There's no cancellation point here, except if tracing is on
-   */
-  SH_MUTEX_LOCK_UNSAFE(mutex_mlock);
-#endif
-
-  page_list = sh_page_locked;
-
   while (page_list != NULL)
     {
-#ifdef WITH_TPT
-      if (i < 32)
-	sl_snprintf(str[i], 64, _("file: %s line: %d page: %d"), 
-		    page_list->file, page_list->line, i+1);
-#endif
       page_list = page_list->next;
       ++i;
     }
-
-#if defined(HAVE_MLOCK) && !defined(HAVE_BROKEN_MLOCK)
-  SH_MUTEX_UNLOCK_UNSAFE(mutex_mlock);
-#endif
-
-#ifdef WITH_TPT
-  {
-    unsigned int j = 0;
-    while (j < i && j < 32)
-      {
-	sh_error_handle(SH_ERR_ALL, FIL__, __LINE__, j, MSG_E_SUBGEN,
-			str[j], _("sh_unix_count_mlock"));
-	++j;
-      }
-  }
-#endif
-
-  sl_snprintf(str[0], 64, _("%d pages locked"), i);
-  sh_error_handle(SH_ERR_ALL, FIL__, __LINE__, i, MSG_E_SUBGEN,
-		  str[0], _("sh_unix_count_mlock"));
+  sprintf(str, _("%d pages locked"), i);               /* known to fit  */
+  sh_error_handle(SH_ERR_INFO, FIL__, __LINE__, i, MSG_E_SUBGEN,
+		  str, _("sh_unix_count_mlock"));
   SL_RETURN((i), _("sh_unix_count_mlock"));
 }
@@ -5411,7 +3897,9 @@
 #if  !defined(SH_STEALTH_MICRO)
 
-
-int hideout_hex_block(SL_TICKET fd, unsigned char * str, int len,
-		      unsigned long * bytes_read);
+static unsigned long off_data = 0;
+static unsigned long max_data = 0;
+static int           stealth_init = BAD;
+
+int hideout_hex_block(SL_TICKET fd, unsigned char * str, int len);
 unsigned long first_hex_block(SL_TICKET fd, unsigned long * max);
 
@@ -5421,21 +3909,7 @@
 int sh_unix_getline_stealth (SL_TICKET fd, char * str, int len)
 {
-  int                  add_off = 0, llen;
-  unsigned long        bread;
-  static unsigned long off_data   = 0;
-  static unsigned long max_data   = 0;
-  static unsigned long bytes_read = 0;
-  static int           stealth_init = BAD;
+  int add_off, llen;
 
   SL_ENTER(_("sh_unix_getline_stealth"));
-
-  if (str == NULL)
-    {
-      off_data   = 0;
-      max_data   = 0;
-      bytes_read = 0;
-      stealth_init = BAD;
-      SL_RETURN(0, _("sh_unix_getline_stealth"));
-    }
 
   /* --- Initialize. ---
@@ -5453,28 +3927,15 @@
 	}
       stealth_init = GOOD;
-      max_data += off_data;
     }
   
   /* --- Seek to proper position. ---
    */
-  if (bytes_read >= max_data || add_off < 0)
-    {
-      dlog(1, FIL__, __LINE__, 
-	   _("The capacity of the container image file for the stealth config file seems to be too small. Your config file is likely truncated.\n"));
-      sh_error_handle ((-1), FIL__, __LINE__,  EIO, MSG_P_NODATA,
-		       _("Stealth config file."));
-      aud_exit (FIL__, __LINE__, EXIT_FAILURE);
-    }
   sl_seek(fd, off_data);
      
   /* --- Read one line. ---
    */
-  add_off   = hideout_hex_block(fd, (unsigned char *) str, len, &bread);
-  if (add_off > 0)
-    off_data += add_off;
-  bytes_read += bread;
-
-  if (bread == 0 || add_off <= 0) /* EOF */
-    str[0] = '\0';
+  add_off   = hideout_hex_block(fd, (unsigned char *) str, len);
+  off_data += add_off;
+
 
   llen = sl_strlen(str);
@@ -5482,6 +3943,5 @@
 }
 
-int hideout_hex_block(SL_TICKET fd, unsigned char * str, int len, 
-		      unsigned long * bytes_read)
+int hideout_hex_block(SL_TICKET fd, unsigned char * str, int len)
 {
 
@@ -5492,13 +3952,6 @@
   unsigned long here   = 0;
   unsigned long retval = 0;
-  unsigned long bread  = 0;
 
   SL_ENTER(_("hideout_hex_block"));
-
-  ASSERT_RET((len > 1), _("len > 1"), (0));
-
-  str[0] = '\0';
-  *bytes_read = 0;
-  --len;
 
   i = 0;
@@ -5517,15 +3970,9 @@
 	      do {
 		do {
-		  errno = 0;
 		  num = sl_read (fd, &c, 1);
 		} while (num == 0 && errno == EINTR);
-		if (num > 0)
-		  ++here;
-		else if (num == 0) {
+		if (num == 0) 
 		  SL_RETURN((-1), _("hideout_hex_block"));
-		}
-		else {
-		  SL_RETURN((-1), _("hideout_hex_block"));
-		}
+		++here; 
 	      } while (c == '\n' || c == '\t' || c == '\r' || 
 		       c == ' ');
@@ -5541,5 +3988,4 @@
 	    str[i] &= ~mask[j];
 
-	  bread += 1;
 	}
       if (str[i] == '\n') break;
@@ -5549,10 +3995,7 @@
   if (i != 0)
     str[i] = '\0';
-  else if (str[0] == '\n')
-    str[i+1] = '\0'; /* keep newline and terminate */
   else
-    str[0] = '\0';
+    str[i+1] = '\0';
   retval += here;
-  *bytes_read += (bread/8);
 
   SL_RETURN(retval, _("hideout_hex_block"));
@@ -5563,11 +4006,10 @@
 unsigned long first_hex_block(SL_TICKET fd, unsigned long * max)
 {
-  unsigned int  i;
-  long          num = 1;
-  unsigned long lnum;
+  int           i;
+  register int  num = 1;
   char          c;
   int           nothex = 0;
   unsigned long retval = 0;
-  unsigned int  this_line = 0;
+  int           this_line = 0;
   char          theline[SH_BUFSIZE];
 
@@ -5581,5 +4023,5 @@
       this_line  = 0;
       c          = '\0';
-      while (c != '\n' && this_line < (sizeof(theline)-1))
+      while (c != '\n' && num > 0)
 	{
 	  do {
@@ -5590,5 +4032,5 @@
 	  else           
 	    SL_RETURN((0), _("first_hex_block"));
-	  ++this_line;
+	  this_line += num;
 	}
       theline[this_line] = '\0';
@@ -5619,17 +4061,13 @@
 	      num = sl_read (fd, theline, SH_BUFSIZE);
 	    } while (num == 0 && errno == EINTR);
-	    if (num > 0)
-	      {
-		lnum = (unsigned long) num;
-		for (i = 0; i < lnum; ++i)
-		  { 
-		    c = theline[i];
-		    if (c == '\n' || c == '\t' || c == '\r' || c == ' ') 
-		      ;
-		    else if (!isxdigit((int)c))
-		      break;
-		    else
-		      *max += 1;
-		  }
+	    for (i = 0; i < num; ++i)
+	      { 
+		c = theline[i];
+		if (c == '\n' || c == '\t' || c == '\r' || c == ' ') 
+		  ;
+		else if (!isxdigit((int)c))
+		  break;
+		else
+		  *max += 1;
 	      }
 	  } while (num > 0);
@@ -5653,93 +4091,23 @@
  */
 #if defined(SCREW_IT_UP)
-
-#if defined(HAVE_PTHREAD)
-
-static pthread_key_t  gSigtrapVariables_key;
-static pthread_once_t gSigtrapVariables_key_once = PTHREAD_ONCE_INIT;
-
-static inline void make_gSigtrapVariables_key()
-{
-    (void) pthread_key_create(&gSigtrapVariables_key, free);
-}
-
-struct sh_sigtrap_variables * sh_sigtrap_variables_get()
-{
-  void * ptr;
-
-  (void) pthread_once(&gSigtrapVariables_key_once, make_gSigtrapVariables_key);
- 
-  ptr = pthread_getspecific(gSigtrapVariables_key);
-  if (ptr == NULL) {
-    ptr = calloc(1,sizeof(struct sh_sigtrap_variables));
-    if (ptr == NULL) {
-      return NULL;
-    }
-    (void) pthread_setspecific(gSigtrapVariables_key, ptr);
-  }
-
-  return (struct sh_sigtrap_variables *) ptr;
-}
-
-/* !defined(HAVE_PTHREAD) */
-#else
-
-static struct sh_sigtrap_variables global_sigtrap_variables;
-struct sh_sigtrap_variables * sh_sigtrap_variables_get()
-{
-  return &global_sigtrap_variables;
-}
-
-#endif
-
-int sh_sigtrap_max_duration_set (const char * str)
-{
-  /* For security (prevent reloading with larger value)
-   * this value can only be set once.
-   */
-  static int once = 0;
-  int i;
-
-  SL_ENTER(_("sh_sigtrap_max_duration_set"));
-
-  i = atoi (str);
-
-  if (i >= 0 && once == 0)
-    {
-      sh.sigtrap_max_duration = i;
-      once = 1;
-    }
-  else
-    {
-      SL_RETURN ((-1), _("sh_sigtrap_max_duration_set"));
-    }
-  SL_RETURN( (0), _("sh_sigtrap_max_duration_set"));
-}
+volatile int sh_not_traced = 0;
+
+#ifdef HAVE_GETTIMEOFDAY
+struct timeval  save_tv;
+#endif
 
 void sh_sigtrap_handler (int signum)
 {
-  struct sh_sigtrap_variables * sigtrap_variables;
-  sigtrap_variables = sh_sigtrap_variables_get();
-  if (sigtrap_variables == NULL) {
-    /* Perhaps, it's better to not die, and to continue using Samhain,
-       even if this part does not work. */
-    return;
-  }
-
 #ifdef HAVE_GETTIMEOFDAY
-  {
-    struct timeval  tv;
-    long   difftv;
-    
-    gettimeofday(&tv, NULL);
-    difftv = (tv.tv_sec - sigtrap_variables->save_tv.tv_sec) * 1000000 + 
-      (tv.tv_usec - sigtrap_variables->save_tv.tv_usec);
-    if (difftv > sh.sigtrap_max_duration)
-      raise(SIGKILL);
-  }
-#endif
-
-  sigtrap_variables->not_traced = signum;
-  /* cppcheck-suppress memleak */
+  struct timeval  tv;
+  long   difftv;
+  
+  gettimeofday(&tv, NULL);
+  difftv = (tv.tv_sec - save_tv.tv_sec) * 1000000 + 
+    (tv.tv_usec - save_tv.tv_usec);
+  if (difftv > 500000)
+    _exit(6);
+#endif
+  sh_not_traced += signum;
   return;
 }
